Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision d8b94a86944c4679c88bc250bff510f242d63309)
+++ src/moleculelist.cpp	(revision 1907a789609146bbdebfeff09de44cb4ba21b808)
@@ -380,106 +566,118 @@
  * \return true - success (each file was written), false - something went wrong.
  */
-bool MoleculeListClass::OutputConfigForListOfFragments(ofstream *out, config *configuration, int *SortIndex)
-{
-	ofstream outputFragment;
-	char FragmentName[MAXSTRINGSIZE];
-	char PathBackup[MAXSTRINGSIZE];
-	bool result = true;
-	bool intermediateResult = true;
-	atom *Walker = NULL;
-	Vector BoxDimension;
-	char *FragmentNumber = NULL;
-	char *path = NULL;
-	int FragmentCounter = 0;
-	ofstream output;
-	
-	// store the fragments as config and as xyz
-	for(int i=0;i<NumberOfMolecules;i++) {
-		// save default path as it is changed for each fragment
-		path = configuration->GetDefaultPath();
-		if (path != NULL)
-			strcpy(PathBackup, path);
-		else
-			cerr << "OutputConfigForListOfFragments: NULL default path obtained from config!" << endl;
-
-		// correct periodic
-		ListOfMolecules[i]->ScanForPeriodicCorrection(out);
-
-		// output xyz file
-		FragmentNumber = FixedDigitNumber(NumberOfMolecules, FragmentCounter++);
-		sprintf(FragmentName, "%s/%s%s.conf.xyz", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
-		outputFragment.open(FragmentName, ios::out);
-		*out << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter-1 << " as XYZ ...";
-		if ((intermediateResult = ListOfMolecules[i]->OutputXYZ(&outputFragment)))
-			*out << " done." << endl;
-		else
-			*out << " failed." << endl;
-		result = result && intermediateResult;
-		outputFragment.close();
-		outputFragment.clear();
-
-		// list atoms in fragment for debugging
-		*out << Verbose(2) << "Contained atoms: ";
-		Walker = ListOfMolecules[i]->start;
-		while (Walker->next != ListOfMolecules[i]->end) {
-			Walker = Walker->next;
-			*out << Walker->Name << " ";
-		}
-		*out << endl;
-		
-		// center on edge
-		ListOfMolecules[i]->CenterEdge(out, &BoxDimension);
-		ListOfMolecules[i]->SetBoxDimension(&BoxDimension);	// update Box of atoms by boundary
-		int j = -1;
-		for (int k=0;k<NDIM;k++) {
-			j += k+1;
-			BoxDimension.x[k] = 2.5* (configuration->GetIsAngstroem() ? 1. : 1./AtomicLengthToAngstroem);
-			ListOfMolecules[i]->cell_size[j] += BoxDimension.x[k]*2.;
-		}
-		ListOfMolecules[i]->Translate(&BoxDimension);
-
-		// also calculate necessary orbitals
-		ListOfMolecules[i]->CountElements();	// this is a bugfix, atoms should should actually be added correctly to this fragment 
-		ListOfMolecules[i]->CalculateOrbitals(*configuration);
-		
-		// change path in config
-		//strcpy(PathBackup, configuration->configpath);
-		sprintf(FragmentName, "%s/%s%s/", PathBackup, FRAGMENTPREFIX, FragmentNumber);
-		configuration->SetDefaultPath(FragmentName);
-		
-		// and save as config
-		sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
-		*out << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter-1 << " as config ...";
-		if ((intermediateResult = configuration->Save(FragmentName, ListOfMolecules[i]->elemente, ListOfMolecules[i])))
-			*out << " done." << endl;
-		else
-			*out << " failed." << endl;
-		result = result && intermediateResult;
-
-		// restore old config
-		configuration->SetDefaultPath(PathBackup);
-
-
-		// and save as mpqc input file
-		sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
-		*out << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter-1 << " as mpqc input ...";
-		if ((intermediateResult = configuration->SaveMPQC(FragmentName, ListOfMolecules[i])))
-			*out << " done." << endl;
-		else
-			*out << " failed." << endl;
-			 
-		result = result && intermediateResult;
-		//outputFragment.close();
-		//outputFragment.clear();
-		delete(FragmentNumber);
-		//Free((void **)&FragmentNumber, "MoleculeListClass::OutputConfigForListOfFragments: *FragmentNumber");
-	}
-	cout << " done." << endl;
-	
-	// printing final number
-	*out << "Final number of fragments: " << FragmentCounter << "." << endl;
-			
-	return result;
-};
+bool MoleculeListClass::OutputConfigForListOfFragments(ofstream *out,
+    config *configuration, int *SortIndex)
+{
+  ofstream outputFragment;
+  char FragmentName[MAXSTRINGSIZE];
+  char PathBackup[MAXSTRINGSIZE];
+  bool result = true;
+  bool intermediateResult = true;
+  atom *Walker = NULL;
+  Vector BoxDimension;
+  char *FragmentNumber = NULL;
+  char *path = NULL;
+  int FragmentCounter = 0;
+  ofstream output;
+
+  // store the fragments as config and as xyz
+  for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
+    // save default path as it is changed for each fragment
+    path = configuration->GetDefaultPath();
+    if (path != NULL)
+      strcpy(PathBackup, path);
+    else
+      cerr << "OutputConfigForListOfFragments: NULL default path obtained from config!" << endl;
+
+    // correct periodic
+    (*ListRunner)->ScanForPeriodicCorrection(out);
+
+    // output xyz file
+    FragmentNumber = FixedDigitNumber(ListOfMolecules.size(), FragmentCounter++);
+    sprintf(FragmentName, "%s/%s%s.conf.xyz", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
+    outputFragment.open(FragmentName, ios::out);
+    *out << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as XYZ ...";
+    if ((intermediateResult = (*ListRunner)->OutputXYZ(&outputFragment)))
+      *out << " done." << endl;
+    else
+      *out << " failed." << endl;
+    result = result && intermediateResult;
+    outputFragment.close();
+    outputFragment.clear();
+
+    // list atoms in fragment for debugging
+    *out << Verbose(2) << "Contained atoms: ";
+    Walker = (*ListRunner)->start;
+    while (Walker->next != (*ListRunner)->end) {
+      Walker = Walker->next;
+      *out << Walker->Name << " ";
+    }
+    *out << endl;
+
+    // center on edge
+    (*ListRunner)->CenterEdge(out, &BoxDimension);
+    (*ListRunner)->SetBoxDimension(&BoxDimension); // update Box of atoms by boundary
+    int j = -1;
+    for (int k = 0; k < NDIM; k++) {
+      j += k + 1;
+      BoxDimension.x[k] = 2.5 * (configuration->GetIsAngstroem() ? 1. : 1. / AtomicLengthToAngstroem);
+      (*ListRunner)->cell_size[j] += BoxDimension.x[k] * 2.;
+    }
+    (*ListRunner)->Translate(&BoxDimension);
+
+    // also calculate necessary orbitals
+    (*ListRunner)->CountElements(); // this is a bugfix, atoms should shoulds actually be added correctly to this fragment
+    (*ListRunner)->CalculateOrbitals(*configuration);
+
+    // change path in config
+    //strcpy(PathBackup, configuration->configpath);
+    sprintf(FragmentName, "%s/%s%s/", PathBackup, FRAGMENTPREFIX, FragmentNumber);
+    configuration->SetDefaultPath(FragmentName);
+
+    // and save as config
+    sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
+    *out << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as config ...";
+    if ((intermediateResult = configuration->Save(FragmentName, (*ListRunner)->elemente, (*ListRunner))))
+      *out << " done." << endl;
+    else
+      *out << " failed." << endl;
+    result = result && intermediateResult;
+
+    // restore old config
+    configuration->SetDefaultPath(PathBackup);
+
+    // and save as mpqc input file
+    sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
+    *out << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as mpqc input ...";
+    if ((intermediateResult = configuration->SaveMPQC(FragmentName, (*ListRunner))))
+      *out << " done." << endl;
+    else
+      *out << " failed." << endl;
+
+    result = result && intermediateResult;
+    //outputFragment.close();
+    //outputFragment.clear();
+    delete (FragmentNumber);
+    //Free((void **)&FragmentNumber, "MoleculeListClass::OutputConfigForListOfFragments: *FragmentNumber");
+  }
+  cout << " done." << endl;
+
+  // printing final number
+  *out << "Final number of fragments: " << FragmentCounter << "." << endl;
+
+  return result;
+};
+
+/** Counts the number of molecules with the molecule::ActiveFlag set.
+ * \return number of molecules with ActiveFlag set to true.
+ */
+int MoleculeListClass::NumberOfActiveMolecules()
+{
+  int count = 0;
+  for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++)
+    count += ((*ListRunner)->ActiveFlag ? 1 : 0);
+  return count;
+};
+
 
 /******************************************* Class MoleculeLeafClass ************************************************/
@@ -492,18 +690,18 @@
 MoleculeLeafClass::MoleculeLeafClass(MoleculeLeafClass *PreviousLeaf = NULL)
 {
-//	if (Up != NULL)
-//		if (Up->DownLeaf == NULL) // are we the first down leaf for the upper leaf?
-//			Up->DownLeaf = this;
-//	UpLeaf = Up;
-//	DownLeaf = NULL;
-	Leaf = NULL;
-	previous = PreviousLeaf;
-	if (previous != NULL) {
-		MoleculeLeafClass *Walker = previous->next;
-		previous->next = this;
-		next = Walker;
-	} else {
-		next = NULL;
-	}
+  //	if (Up != NULL)
+  //		if (Up->DownLeaf == NULL) // are we the first down leaf for the upper leaf?
+  //			Up->DownLeaf = this;
+  //	UpLeaf = Up;
+  //	DownLeaf = NULL;
+  Leaf = NULL;
+  previous = PreviousLeaf;
+  if (previous != NULL) {
+    MoleculeLeafClass *Walker = previous->next;
+    previous->next = this;
+    next = Walker;
+  } else {
+    next = NULL;
+  }
 };
 
@@ -512,33 +710,33 @@
 MoleculeLeafClass::~MoleculeLeafClass()
 {
-//	if (DownLeaf != NULL) {// drop leaves further down
-//		MoleculeLeafClass *Walker = DownLeaf;
-//		MoleculeLeafClass *Next;
-//		do {
-//			Next = Walker->NextLeaf;
-//			delete(Walker);
-//			Walker = Next;
-//		} while (Walker != NULL);
-//		// Last Walker sets DownLeaf automatically to NULL
-//	}
-	// remove the leaf itself
-	if (Leaf != NULL) {
-		delete(Leaf);
-		Leaf = NULL;
-	}
-	// remove this Leaf from level list
-	if (previous != NULL)	 
-		previous->next = next;
-//	} else { // we are first in list (connects to UpLeaf->DownLeaf)
-//		if ((NextLeaf != NULL) && (NextLeaf->UpLeaf == NULL))
-//			NextLeaf->UpLeaf = UpLeaf;	// either null as we are top level or the upleaf of the first node
-//		if (UpLeaf != NULL)
-//			UpLeaf->DownLeaf = NextLeaf;	// either null as we are only leaf or NextLeaf if we are just the first
-//	}
-//	UpLeaf = NULL;
-	if (next != NULL) // are we last in list
-		next->previous = previous;
-	next = NULL;
-	previous = NULL;
+  //	if (DownLeaf != NULL) {// drop leaves further down
+  //		MoleculeLeafClass *Walker = DownLeaf;
+  //		MoleculeLeafClass *Next;
+  //		do {
+  //			Next = Walker->NextLeaf;
+  //			delete(Walker);
+  //			Walker = Next;
+  //		} while (Walker != NULL);
+  //		// Last Walker sets DownLeaf automatically to NULL
+  //	}
+  // remove the leaf itself
+  if (Leaf != NULL) {
+    delete (Leaf);
+    Leaf = NULL;
+  }
+  // remove this Leaf from level list
+  if (previous != NULL)
+    previous->next = next;
+  //	} else { // we are first in list (connects to UpLeaf->DownLeaf)
+  //		if ((NextLeaf != NULL) && (NextLeaf->UpLeaf == NULL))
+  //			NextLeaf->UpLeaf = UpLeaf;	// either null as we are top level or the upleaf of the first node
+  //		if (UpLeaf != NULL)
+  //			UpLeaf->DownLeaf = NextLeaf;	// either null as we are only leaf or NextLeaf if we are just the first
+  //	}
+  //	UpLeaf = NULL;
+  if (next != NULL) // are we last in list
+    next->previous = previous;
+  next = NULL;
+  previous = NULL;
 };
 
@@ -550,5 +748,5 @@
 bool MoleculeLeafClass::AddLeaf(molecule *ptr, MoleculeLeafClass *Previous)
 {
-	return false;
+  return false;
 };
 
@@ -564,50 +762,51 @@
 bool MoleculeLeafClass::FillBondStructureFromReference(ofstream *out, molecule *reference, int &FragmentCounter, atom ***&ListOfLocalAtoms, bool FreeList)
 {
-	atom *Walker = NULL, *OtherWalker = NULL;
-	bond *Binder = NULL;
-	bool status = true;
-	int AtomNo;
-
-	*out << Verbose(1) << "Begin of FillBondStructureFromReference." << endl;
-	// fill ListOfLocalAtoms if NULL was given
-	if (!FillListOfLocalAtoms(out, ListOfLocalAtoms, FragmentCounter, reference->AtomCount, FreeList)) {
-		*out << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl;
-		return false;
-	}
-	
-	if (status) {
-		*out << Verbose(1) << "Creating adjacency list for subgraph " << this << "." << endl;
-		Walker = Leaf->start;
-		while (Walker->next != Leaf->end) {
-			Walker = Walker->next;
-			AtomNo = Walker->GetTrueFather()->nr;	// global id of the current walker
-			for(int i=0;i<reference->NumberOfBondsPerAtom[AtomNo];i++) { // go through father's bonds and copy them all
-				Binder = reference->ListOfBondsPerAtom[AtomNo][i];
-				OtherWalker = ListOfLocalAtoms[FragmentCounter][Binder->GetOtherAtom(Walker->GetTrueFather())->nr];		// local copy of current bond partner of walker
-				if (OtherWalker != NULL) {
-					if (OtherWalker->nr > Walker->nr)
-					Leaf->AddBond(Walker, OtherWalker, Binder->BondDegree);
-				} else {
-					*out << Verbose(1) << "OtherWalker = ListOfLocalAtoms[" << FragmentCounter << "][" << Binder->GetOtherAtom(Walker->GetTrueFather())->nr << "] is NULL!" << endl;
-					status = false;
-				}
-			}
-		}
-		Leaf->CreateListOfBondsPerAtom(out);
-		FragmentCounter++;
-		if (next != NULL)
-			status = next->FillBondStructureFromReference(out, reference, FragmentCounter, ListOfLocalAtoms);
-		FragmentCounter--;
-	}
-	
-	if ((FreeList) && (ListOfLocalAtoms != NULL)) {
-		// free the index lookup list
-		Free((void **)&ListOfLocalAtoms[FragmentCounter], "MoleculeLeafClass::FillBondStructureFromReference - **ListOfLocalAtoms[]");
-		if (FragmentCounter == 0) // first fragments frees the initial pointer to list
-			Free((void **)&ListOfLocalAtoms, "MoleculeLeafClass::FillBondStructureFromReference - ***ListOfLocalAtoms");
-	}
-	FragmentCounter--;
-	*out << Verbose(1) << "End of FillBondStructureFromReference." << endl;
-	return status;
+  atom *Walker = NULL, *OtherWalker = NULL;
+  bond *Binder = NULL;
+  bool status = true;
+  int AtomNo;
+
+  *out << Verbose(1) << "Begin of FillBondStructureFromReference." << endl;
+  // fill ListOfLocalAtoms if NULL was given
+  if (!FillListOfLocalAtoms(out, ListOfLocalAtoms, FragmentCounter, reference->AtomCount, FreeList)) {
+    *out << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl;
+    return false;
+  }
+
+  if (status) {
+    *out << Verbose(1) << "Creating adjacency list for subgraph " << this
+        << "." << endl;
+    Walker = Leaf->start;
+    while (Walker->next != Leaf->end) {
+      Walker = Walker->next;
+      AtomNo = Walker->GetTrueFather()->nr; // global id of the current walker
+      for (int i = 0; i < reference->NumberOfBondsPerAtom[AtomNo]; i++) { // go through father's bonds and copy them all
+        Binder = reference->ListOfBondsPerAtom[AtomNo][i];
+        OtherWalker = ListOfLocalAtoms[FragmentCounter][Binder->GetOtherAtom(Walker->GetTrueFather())->nr]; // local copy of current bond partner of walker
+        if (OtherWalker != NULL) {
+          if (OtherWalker->nr > Walker->nr)
+            Leaf->AddBond(Walker, OtherWalker, Binder->BondDegree);
+        } else {
+          *out << Verbose(1) << "OtherWalker = ListOfLocalAtoms[" << FragmentCounter << "][" << Binder->GetOtherAtom(Walker->GetTrueFather())->nr << "] is NULL!" << endl;
+          status = false;
+        }
+      }
+    }
+    Leaf->CreateListOfBondsPerAtom(out);
+    FragmentCounter++;
+    if (next != NULL)
+      status = next->FillBondStructureFromReference(out, reference, FragmentCounter, ListOfLocalAtoms);
+    FragmentCounter--;
+  }
+
+  if ((FreeList) && (ListOfLocalAtoms != NULL)) {
+    // free the index lookup list
+    Free((void **) &ListOfLocalAtoms[FragmentCounter], "MoleculeLeafClass::FillBondStructureFromReference - **ListOfLocalAtoms[]");
+    if (FragmentCounter == 0) // first fragments frees the initial pointer to list
+      Free((void **) &ListOfLocalAtoms, "MoleculeLeafClass::FillBondStructureFromReference - ***ListOfLocalAtoms");
+  }
+  FragmentCounter--;
+  *out << Verbose(1) << "End of FillBondStructureFromReference." << endl;
+  return status;
 };
 
@@ -620,34 +819,35 @@
  * \return true - stack is non-empty, fragmentation necessary, false - stack is empty, no more sites to update
  */
-bool MoleculeLeafClass::FillRootStackForSubgraphs(ofstream *out, KeyStack *&RootStack, bool *AtomMask, int &FragmentCounter)
-{
-	atom *Walker = NULL, *Father = NULL;
-
-	if (RootStack != NULL) {
-		// find first root candidates 
-		if (&(RootStack[FragmentCounter]) != NULL) {
-			RootStack[FragmentCounter].clear();	
-			Walker = Leaf->start;
-			while (Walker->next != Leaf->end) { // go through all (non-hydrogen) atoms
-				Walker = Walker->next;
-				Father = Walker->GetTrueFather();
-				if (AtomMask[Father->nr]) // apply mask
-		#ifdef ADDHYDROGEN
-					if (Walker->type->Z != 1) // skip hydrogen
-		#endif
-						RootStack[FragmentCounter].push_front(Walker->nr);
-			}
-			if (next != NULL)
-				next->FillRootStackForSubgraphs(out, RootStack, AtomMask, ++FragmentCounter);
-		}	else {
-			*out << Verbose(1) << "Rootstack[" << FragmentCounter	<< "] is NULL." << endl;
-			return false;
-		}
-		FragmentCounter--;
-		return true;
-	} else {
-		*out << Verbose(1) << "Rootstack is NULL." << endl;
-		return false;
-	}
+bool MoleculeLeafClass::FillRootStackForSubgraphs(ofstream *out,
+    KeyStack *&RootStack, bool *AtomMask, int &FragmentCounter)
+{
+  atom *Walker = NULL, *Father = NULL;
+
+  if (RootStack != NULL) {
+    // find first root candidates
+    if (&(RootStack[FragmentCounter]) != NULL) {
+      RootStack[FragmentCounter].clear();
+      Walker = Leaf->start;
+      while (Walker->next != Leaf->end) { // go through all (non-hydrogen) atoms
+        Walker = Walker->next;
+        Father = Walker->GetTrueFather();
+        if (AtomMask[Father->nr]) // apply mask
+#ifdef ADDHYDROGEN
+          if (Walker->type->Z != 1) // skip hydrogen
+#endif
+          RootStack[FragmentCounter].push_front(Walker->nr);
+      }
+      if (next != NULL)
+        next->FillRootStackForSubgraphs(out, RootStack, AtomMask, ++FragmentCounter);
+    } else {
+      *out << Verbose(1) << "Rootstack[" << FragmentCounter << "] is NULL." << endl;
+      return false;
+    }
+    FragmentCounter--;
+    return true;
+  } else {
+    *out << Verbose(1) << "Rootstack is NULL." << endl;
+    return false;
+  }
 };
 
@@ -662,24 +862,24 @@
 bool MoleculeLeafClass::FillListOfLocalAtoms(ofstream *out, atom ***&ListOfLocalAtoms, const int FragmentCounter, const int GlobalAtomCount, bool &FreeList)
 {
-	bool status = true;
-	
-	int Counter = Count();
-	if (ListOfLocalAtoms == NULL) { // allocated initial pointer
-		// allocate and set each field to NULL
-		ListOfLocalAtoms = (atom ***) Malloc(sizeof(atom **)*Counter, "MoleculeLeafClass::FillBondStructureFromReference - ***ListOfLocalAtoms");
-		if (ListOfLocalAtoms != NULL) {
-			for (int i=Counter;i--;)
-				ListOfLocalAtoms[i] = NULL;
-			FreeList = FreeList && true;
-		} else
-			status = false;
-	}
-	
-	if ((ListOfLocalAtoms != NULL) && (ListOfLocalAtoms[FragmentCounter] == NULL)) { // allocate and fill list of this fragment/subgraph
-		status = status && CreateFatherLookupTable(out, Leaf->start, Leaf->end, ListOfLocalAtoms[FragmentCounter], GlobalAtomCount);
-		FreeList = FreeList && true;
-	}
-	
-	return status;
+  bool status = true;
+
+  int Counter = Count();
+  if (ListOfLocalAtoms == NULL) { // allocated initial pointer
+    // allocate and set each field to NULL
+    ListOfLocalAtoms = (atom ***) Malloc(sizeof(atom **) * Counter, "MoleculeLeafClass::FillBondStructureFromReference - ***ListOfLocalAtoms");
+    if (ListOfLocalAtoms != NULL) {
+      for (int i = Counter; i--;)
+        ListOfLocalAtoms[i] = NULL;
+      FreeList = FreeList && true;
+    } else
+      status = false;
+  }
+
+  if ((ListOfLocalAtoms != NULL) && (ListOfLocalAtoms[FragmentCounter] == NULL)) { // allocate and fill list of this fragment/subgraph
+    status = status && CreateFatherLookupTable(out, Leaf->start, Leaf->end, ListOfLocalAtoms[FragmentCounter], GlobalAtomCount);
+    FreeList = FreeList && true;
+  }
+
+  return status;
 };
 
@@ -694,61 +894,63 @@
  * \retuen true - success, false - failure
  */
-bool MoleculeLeafClass::AssignKeySetsToFragment(ofstream *out, molecule *reference, Graph *KeySetList, atom ***&ListOfLocalAtoms, Graph **&FragmentList, int &FragmentCounter, bool FreeList)
-{
-	bool status = true;
-	int KeySetCounter = 0;
-	
-	*out << Verbose(1) << "Begin of AssignKeySetsToFragment." << endl;
-	// fill ListOfLocalAtoms if NULL was given
-	if (!FillListOfLocalAtoms(out, ListOfLocalAtoms, FragmentCounter, reference->AtomCount, FreeList)) {
-		*out << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl;
-		return false;
-	}
-
-	// allocate fragment list
-	if (FragmentList == NULL) {
-		KeySetCounter = Count();
-		FragmentList = (Graph **) Malloc(sizeof(Graph *)*KeySetCounter, "MoleculeLeafClass::AssignKeySetsToFragment - **FragmentList");
-		for(int i=KeySetCounter;i--;)
-			FragmentList[i] = NULL;
-		KeySetCounter = 0;
-	}
-	
-	if ((KeySetList != NULL) && (KeySetList->size() != 0)) { // if there are some scanned keysets at all
-		// assign scanned keysets
-		if (FragmentList[FragmentCounter] == NULL)
-			FragmentList[FragmentCounter] = new Graph;
-		KeySet *TempSet = new KeySet;
-		for(Graph::iterator runner = KeySetList->begin();runner != KeySetList->end(); runner++) { // key sets contain global numbers!
-			if ( ListOfLocalAtoms[FragmentCounter][reference->FindAtom(*((*runner).first.begin()))->nr] != NULL) {// as we may assume that that bond structure is unchanged, we only test the first key in each set
-				// translate keyset to local numbers
-				for(KeySet::iterator sprinter = (*runner).first.begin(); sprinter != (*runner).first.end(); sprinter++)
-					TempSet->insert(ListOfLocalAtoms[FragmentCounter][reference->FindAtom(*sprinter)->nr]->nr);
-				// insert into FragmentList
-				FragmentList[FragmentCounter]->insert(GraphPair (*TempSet, pair<int,double>(KeySetCounter++, (*runner).second.second)));
-			}
-			TempSet->clear();
-		}
-		delete(TempSet);
-		if (KeySetCounter == 0) {// if there are no keysets, delete the list
-			*out << Verbose(1) << "KeySetCounter is zero, deleting FragmentList." << endl;
-			delete(FragmentList[FragmentCounter]);
-		} else
-			*out << Verbose(1) << KeySetCounter << " keysets were assigned to subgraph " << FragmentCounter << "." << endl;
-		FragmentCounter++;
-		if (next != NULL)
-			next->AssignKeySetsToFragment(out, reference, KeySetList, ListOfLocalAtoms, FragmentList, FragmentCounter, FreeList);
-		FragmentCounter--;
-	} else
-		*out << Verbose(1) << "KeySetList is NULL or empty." << endl;
-	
-	if ((FreeList) && (ListOfLocalAtoms != NULL)) {
-		// free the index lookup list
-		Free((void **)&ListOfLocalAtoms[FragmentCounter], "MoleculeLeafClass::AssignKeySetsToFragment - **ListOfLocalAtoms[]");
-		if (FragmentCounter == 0) // first fragments frees the initial pointer to list
-			Free((void **)&ListOfLocalAtoms, "MoleculeLeafClass::AssignKeySetsToFragment - ***ListOfLocalAtoms");
-	}
-	*out << Verbose(1) << "End of AssignKeySetsToFragment." << endl;
-	return status;
+bool MoleculeLeafClass::AssignKeySetsToFragment(ofstream *out,
+    molecule *reference, Graph *KeySetList, atom ***&ListOfLocalAtoms,
+    Graph **&FragmentList, int &FragmentCounter, bool FreeList)
+{
+  bool status = true;
+  int KeySetCounter = 0;
+
+  *out << Verbose(1) << "Begin of AssignKeySetsToFragment." << endl;
+  // fill ListOfLocalAtoms if NULL was given
+  if (!FillListOfLocalAtoms(out, ListOfLocalAtoms, FragmentCounter, reference->AtomCount, FreeList)) {
+    *out << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl;
+    return false;
+  }
+
+  // allocate fragment list
+  if (FragmentList == NULL) {
+    KeySetCounter = Count();
+    FragmentList = (Graph **) Malloc(sizeof(Graph *) * KeySetCounter, "MoleculeLeafClass::AssignKeySetsToFragment - **FragmentList");
+    for (int i = KeySetCounter; i--;)
+      FragmentList[i] = NULL;
+    KeySetCounter = 0;
+  }
+
+  if ((KeySetList != NULL) && (KeySetList->size() != 0)) { // if there are some scanned keysets at all
+    // assign scanned keysets
+    if (FragmentList[FragmentCounter] == NULL)
+      FragmentList[FragmentCounter] = new Graph;
+    KeySet *TempSet = new KeySet;
+    for (Graph::iterator runner = KeySetList->begin(); runner != KeySetList->end(); runner++) { // key sets contain global numbers!
+      if (ListOfLocalAtoms[FragmentCounter][reference->FindAtom(*((*runner).first.begin()))->nr] != NULL) {// as we may assume that that bond structure is unchanged, we only test the first key in each set
+        // translate keyset to local numbers
+        for (KeySet::iterator sprinter = (*runner).first.begin(); sprinter != (*runner).first.end(); sprinter++)
+          TempSet->insert(ListOfLocalAtoms[FragmentCounter][reference->FindAtom(*sprinter)->nr]->nr);
+        // insert into FragmentList
+        FragmentList[FragmentCounter]->insert(GraphPair(*TempSet, pair<int, double> (KeySetCounter++, (*runner).second.second)));
+      }
+      TempSet->clear();
+    }
+    delete (TempSet);
+    if (KeySetCounter == 0) {// if there are no keysets, delete the list
+      *out << Verbose(1) << "KeySetCounter is zero, deleting FragmentList." << endl;
+      delete (FragmentList[FragmentCounter]);
+    } else
+      *out << Verbose(1) << KeySetCounter << " keysets were assigned to subgraph " << FragmentCounter << "." << endl;
+    FragmentCounter++;
+    if (next != NULL)
+      next->AssignKeySetsToFragment(out, reference, KeySetList, ListOfLocalAtoms, FragmentList, FragmentCounter, FreeList);
+    FragmentCounter--;
+  } else
+    *out << Verbose(1) << "KeySetList is NULL or empty." << endl;
+
+  if ((FreeList) && (ListOfLocalAtoms != NULL)) {
+    // free the index lookup list
+    Free((void **) &ListOfLocalAtoms[FragmentCounter], "MoleculeLeafClass::AssignKeySetsToFragment - **ListOfLocalAtoms[]");
+    if (FragmentCounter == 0) // first fragments frees the initial pointer to list
+      Free((void **) &ListOfLocalAtoms, "MoleculeLeafClass::AssignKeySetsToFragment - ***ListOfLocalAtoms");
+  }
+  *out << Verbose(1) << "End of AssignKeySetsToFragment." << endl;
+  return status;
 };
 
@@ -759,24 +961,26 @@
  * \param &TotalNumberOfKeySets global key set counter
  * \param &TotalGraph Graph to be filled with global numbers
- */ 
-void MoleculeLeafClass::TranslateIndicesToGlobalIDs(ofstream *out, Graph **FragmentList, int &FragmentCounter, int &TotalNumberOfKeySets, Graph &TotalGraph)
-{
-	*out << Verbose(1) << "Begin of TranslateIndicesToGlobalIDs." << endl;
-	KeySet *TempSet = new KeySet;
-	if (FragmentList[FragmentCounter] != NULL) {
-		for(Graph::iterator runner = FragmentList[FragmentCounter]->begin(); runner != FragmentList[FragmentCounter]->end(); runner++) {
-			for(KeySet::iterator sprinter = (*runner).first.begin(); sprinter != (*runner).first.end(); sprinter++)
-				TempSet->insert((Leaf->FindAtom(*sprinter))->GetTrueFather()->nr);
-			TotalGraph.insert(GraphPair(*TempSet, pair<int,double>(TotalNumberOfKeySets++, (*runner).second.second)));
-			TempSet->clear();
-		}
-		delete(TempSet);
-	} else {
-		*out << Verbose(1) << "FragmentList is NULL." << endl;
-	}
-	if (next != NULL)
-		next->TranslateIndicesToGlobalIDs(out, FragmentList, ++FragmentCounter, TotalNumberOfKeySets, TotalGraph);
-	FragmentCounter--;
-	*out << Verbose(1) << "End of TranslateIndicesToGlobalIDs." << endl;
+ */
+void MoleculeLeafClass::TranslateIndicesToGlobalIDs(ofstream *out,
+    Graph **FragmentList, int &FragmentCounter, int &TotalNumberOfKeySets,
+    Graph &TotalGraph)
+{
+  *out << Verbose(1) << "Begin of TranslateIndicesToGlobalIDs." << endl;
+  KeySet *TempSet = new KeySet;
+  if (FragmentList[FragmentCounter] != NULL) {
+    for (Graph::iterator runner = FragmentList[FragmentCounter]->begin(); runner != FragmentList[FragmentCounter]->end(); runner++) {
+      for (KeySet::iterator sprinter = (*runner).first.begin(); sprinter != (*runner).first.end(); sprinter++)
+        TempSet->insert((Leaf->FindAtom(*sprinter))->GetTrueFather()->nr);
+      TotalGraph.insert(GraphPair(*TempSet, pair<int, double> (TotalNumberOfKeySets++, (*runner).second.second)));
+      TempSet->clear();
+    }
+    delete (TempSet);
+  } else {
+    *out << Verbose(1) << "FragmentList is NULL." << endl;
+  }
+  if (next != NULL)
+    next->TranslateIndicesToGlobalIDs(out, FragmentList, ++FragmentCounter, TotalNumberOfKeySets, TotalGraph);
+  FragmentCounter--;
+  *out << Verbose(1) << "End of TranslateIndicesToGlobalIDs." << endl;
 };
 
@@ -786,7 +990,8 @@
 int MoleculeLeafClass::Count() const
 {
-	if (next != NULL)
-		return next->Count()+1;
-	else
-		return 1; 
-};
+  if (next != NULL)
+    return next->Count() + 1;
+  else
+    return 1;
+};
+
